'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _CacheEntry = require('./CacheEntry');

var _CacheEntry2 = _interopRequireDefault(_CacheEntry);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Factory for creating instances of {@linkcode CacheEntry}.
 */
class CacheFactory {
  static get $dependencies() {
    return [];
  }

  /**
   * Create new instance of {@linkcode CacheEntry} with value a ttl.
   *
   * @param {*} value The cache entry value.
   * @param {?number=} ttl Cache entry time to live in milliseconds. The
   *        entry will expire after the specified amount of milliseconds.
   * @return {CacheEntry} The created cache entry.
   */
  createCacheEntry(value, ttl) {
    return new _CacheEntry2.default(value, ttl);
  }
}
exports.default = CacheFactory;

typeof $IMA !== 'undefined' && $IMA !== null && $IMA.Loader && $IMA.Loader.register('ima/cache/CacheFactory', [], function (_export, _context) {
 'use strict';
 return {
   setters: [],
   execute: function () {
     _export('default', exports.default);
   }
 };
});
