'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _vendorLinker = require('../vendorLinker');

var _vendorLinker2 = _interopRequireDefault(_vendorLinker);

var _Cache = require('../cache/Cache');

var _Cache2 = _interopRequireDefault(_Cache);

var _CacheFactory = require('../cache/CacheFactory');

var _CacheFactory2 = _interopRequireDefault(_CacheFactory);

var _CacheImpl = require('../cache/CacheImpl');

var _CacheImpl2 = _interopRequireDefault(_CacheImpl);

var _ControllerDecorator = require('../controller/ControllerDecorator');

var _ControllerDecorator2 = _interopRequireDefault(_ControllerDecorator);

var _AbstractController = require('../controller/AbstractController');

var _AbstractController2 = _interopRequireDefault(_AbstractController);

var _DevTool = require('../debug/DevTool');

var _DevTool2 = _interopRequireDefault(_DevTool);

var _Dictionary = require('../dictionary/Dictionary');

var _Dictionary2 = _interopRequireDefault(_Dictionary);

var _MessageFormatDictionary = require('../dictionary/MessageFormatDictionary');

var _MessageFormatDictionary2 = _interopRequireDefault(_MessageFormatDictionary);

var _EventBus = require('../event/EventBus');

var _EventBus2 = _interopRequireDefault(_EventBus);

var _EventBusImpl = require('../event/EventBusImpl');

var _EventBusImpl2 = _interopRequireDefault(_EventBusImpl);

var _Dispatcher = require('../event/Dispatcher');

var _Dispatcher2 = _interopRequireDefault(_Dispatcher);

var _DispatcherImpl = require('../event/DispatcherImpl');

var _DispatcherImpl2 = _interopRequireDefault(_DispatcherImpl);

var _AbstractExtension = require('../extension/AbstractExtension');

var _AbstractExtension2 = _interopRequireDefault(_AbstractExtension);

var _GenericError = require('../error/GenericError');

var _GenericError2 = _interopRequireDefault(_GenericError);

var _HttpAgent = require('../http/HttpAgent');

var _HttpAgent2 = _interopRequireDefault(_HttpAgent);

var _HttpAgentImpl = require('../http/HttpAgentImpl');

var _HttpAgentImpl2 = _interopRequireDefault(_HttpAgentImpl);

var _HttpProxy = require('../http/HttpProxy');

var _HttpProxy2 = _interopRequireDefault(_HttpProxy);

var _StatusCode = require('../http/StatusCode');

var _StatusCode2 = _interopRequireDefault(_StatusCode);

var _UrlTransformer = require('../http/UrlTransformer');

var _UrlTransformer2 = _interopRequireDefault(_UrlTransformer);

var _MetaManager = require('../meta/MetaManager');

var _MetaManager2 = _interopRequireDefault(_MetaManager);

var _MetaManagerImpl = require('../meta/MetaManagerImpl');

var _MetaManagerImpl2 = _interopRequireDefault(_MetaManagerImpl);

var _componentHelpers = require('../page/componentHelpers');

var _AbstractComponent = require('../page/AbstractComponent');

var _AbstractComponent2 = _interopRequireDefault(_AbstractComponent);

var _AbstractPureComponent = require('../page/AbstractPureComponent');

var _AbstractPureComponent2 = _interopRequireDefault(_AbstractPureComponent);

var _PageFactory = require('../page/PageFactory');

var _PageFactory2 = _interopRequireDefault(_PageFactory);

var _ClientPageManager = require('../page/manager/ClientPageManager');

var _ClientPageManager2 = _interopRequireDefault(_ClientPageManager);

var _PageManager = require('../page/manager/PageManager');

var _PageManager2 = _interopRequireDefault(_PageManager);

var _ServerPageManager = require('../page/manager/ServerPageManager');

var _ServerPageManager2 = _interopRequireDefault(_ServerPageManager);

var _ClientPageRenderer = require('../page/renderer/ClientPageRenderer');

var _ClientPageRenderer2 = _interopRequireDefault(_ClientPageRenderer);

var _PageRenderer = require('../page/renderer/PageRenderer');

var _PageRenderer2 = _interopRequireDefault(_PageRenderer);

var _PageRendererFactory = require('../page/renderer/PageRendererFactory');

var _PageRendererFactory2 = _interopRequireDefault(_PageRendererFactory);

var _ServerPageRenderer = require('../page/renderer/ServerPageRenderer');

var _ServerPageRenderer2 = _interopRequireDefault(_ServerPageRenderer);

var _PageStateManager = require('../page/state/PageStateManager');

var _PageStateManager2 = _interopRequireDefault(_PageStateManager);

var _PageStateManagerDecorator = require('../page/state/PageStateManagerDecorator');

var _PageStateManagerDecorator2 = _interopRequireDefault(_PageStateManagerDecorator);

var _PageStateManagerImpl = require('../page/state/PageStateManagerImpl');

var _PageStateManagerImpl2 = _interopRequireDefault(_PageStateManagerImpl);

var _ClientRouter = require('../router/ClientRouter');

var _ClientRouter2 = _interopRequireDefault(_ClientRouter);

var _Events = require('../router/Events');

var _Events2 = _interopRequireDefault(_Events);

var _Request = require('../router/Request');

var _Request2 = _interopRequireDefault(_Request);

var _Response = require('../router/Response');

var _Response2 = _interopRequireDefault(_Response);

var _RouteFactory = require('../router/RouteFactory');

var _RouteFactory2 = _interopRequireDefault(_RouteFactory);

var _RouteNames = require('../router/RouteNames');

var _RouteNames2 = _interopRequireDefault(_RouteNames);

var _Router = require('../router/Router');

var _Router2 = _interopRequireDefault(_Router);

var _ServerRouter = require('../router/ServerRouter');

var _ServerRouter2 = _interopRequireDefault(_ServerRouter);

var _CookieStorage = require('../storage/CookieStorage');

var _CookieStorage2 = _interopRequireDefault(_CookieStorage);

var _MapStorage = require('../storage/MapStorage');

var _MapStorage2 = _interopRequireDefault(_MapStorage);

var _SessionMapStorage = require('../storage/SessionMapStorage');

var _SessionMapStorage2 = _interopRequireDefault(_SessionMapStorage);

var _SessionStorage = require('../storage/SessionStorage');

var _SessionStorage2 = _interopRequireDefault(_SessionStorage);

var _WeakMapStorage = require('../storage/WeakMapStorage');

var _WeakMapStorage2 = _interopRequireDefault(_WeakMapStorage);

var _ClientWindow = require('../window/ClientWindow');

var _ClientWindow2 = _interopRequireDefault(_ClientWindow);

var _ServerWindow = require('../window/ServerWindow');

var _ServerWindow2 = _interopRequireDefault(_ServerWindow);

var _Window = require('../window/Window');

var _Window2 = _interopRequireDefault(_Window);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//eslint-disable-line no-unused-vars
//eslint-disable-line no-unused-vars
//eslint-disable-line no-unused-vars
exports.default = (ns, oc, config) => {
  //**************START VENDORS**************

  oc.constant('$Helper', _vendorLinker2.default.get('ima-helpers', true));

  //React
  oc.constant('$React', _vendorLinker2.default.get('react', true));
  oc.constant('$ReactDOM', _vendorLinker2.default.get('react-dom', true));
  oc.constant('$ReactDOMServer', _vendorLinker2.default.get('react-dom/server.js', true));
  //*************END VENDORS*****************

  //*************START CONSTANTS*****************
  oc.constant('$Settings', config);
  oc.constant('$Env', config.$Env);
  oc.constant('$Protocol', config.$Protocol);
  oc.constant('$Secure', config.$Protocol === 'https:');
  //*************END CONSTANTS*****************

  //*************START IMA**************

  //Request & Response
  oc.bind('$Request', _Request2.default);
  oc.bind('$Response', _Response2.default);

  //Window helper
  if (typeof window !== 'undefined' && window !== null) {
    oc.provide(_Window2.default, _ClientWindow2.default);
  } else {
    oc.provide(_Window2.default, _ServerWindow2.default);
  }
  oc.bind('$Window', _Window2.default);

  //IMA Error
  oc.bind('$Error', _GenericError2.default);

  //Dictionary
  oc.provide(_Dictionary2.default, _MessageFormatDictionary2.default);
  oc.bind('$Dictionary', _Dictionary2.default);

  //Storage
  oc.constant('$CookieTransformFunction', { encode: s => s, decode: s => s });
  oc.bind('$CookieStorage', _CookieStorage2.default);
  if (oc.get(_Window2.default).hasSessionStorage()) {
    oc.bind('$SessionStorage', _SessionStorage2.default);
  } else {
    oc.bind('$SessionStorage', _MapStorage2.default);
  }
  oc.bind('$MapStorage', _MapStorage2.default);
  oc.inject(_WeakMapStorage2.default, [{
    entryTtl: 30 * 60 * 1000,
    maxEntries: 1000,
    gcInterval: 60 * 1000,
    gcEntryCountTreshold: 16
  }]);
  oc.bind('$WeakMapStorage', _WeakMapStorage2.default);
  oc.bind('$SessionMapStorage', _SessionMapStorage2.default);

  // Dispatcher
  oc.provide(_Dispatcher2.default, _DispatcherImpl2.default);
  oc.bind('$Dispatcher', _Dispatcher2.default);

  // Custom Event Bus
  oc.provide(_EventBus2.default, _EventBusImpl2.default);
  oc.bind('$EventBus', _EventBus2.default);

  //Cache
  if (oc.get('$Window').hasSessionStorage()) {
    oc.constant('$CacheStorage', oc.get(_SessionMapStorage2.default));
  } else {
    oc.constant('$CacheStorage', oc.get(_MapStorage2.default));
  }
  oc.bind('$CacheFactory', _CacheFactory2.default);
  oc.provide(_Cache2.default, _CacheImpl2.default, ['$CacheStorage', _CacheFactory2.default, '$Helper', config.$Cache]);
  oc.bind('$Cache', _Cache2.default);

  //SEO
  oc.provide(_MetaManager2.default, _MetaManagerImpl2.default);
  oc.bind('$MetaManager', _MetaManager2.default);
  oc.bind('$ControllerDecorator', _ControllerDecorator2.default);
  oc.bind('$PageStateManagerDecorator', _PageStateManagerDecorator2.default);

  // UI components
  oc.bind('$CssClasses', function () {
    return _componentHelpers.defaultCssClasses;
  });

  //Page
  oc.provide(_PageStateManager2.default, _PageStateManagerImpl2.default);
  oc.bind('$PageStateManager', _PageStateManager2.default);
  oc.inject(_PageFactory2.default, [oc]);
  oc.bind('$PageFactory', _PageFactory2.default);
  oc.inject(_PageRendererFactory2.default, [oc, '$React']);
  oc.bind('$PageRendererFactory', _PageRendererFactory2.default);

  if (oc.get(_Window2.default).isClient()) {
    oc.provide(_PageRenderer2.default, _ClientPageRenderer2.default, [_PageRendererFactory2.default, '$Helper', '$ReactDOM', '$Settings', _Window2.default]);
  } else {
    oc.provide(_PageRenderer2.default, _ServerPageRenderer2.default, [_PageRendererFactory2.default, '$Helper', '$ReactDOMServer', '$Settings', _Response2.default, _Cache2.default]);
  }
  oc.bind('$PageRenderer', _PageRenderer2.default);

  if (oc.get(_Window2.default).isClient()) {
    oc.provide(_PageManager2.default, _ClientPageManager2.default);
  } else {
    oc.provide(_PageManager2.default, _ServerPageManager2.default);
  }
  oc.bind('$PageManager', _PageManager2.default);

  //Router
  oc.bind('$RouteFactory', _RouteFactory2.default);

  if (oc.get(_Window2.default).isClient()) {
    oc.provide(_Router2.default, _ClientRouter2.default);
  } else {
    oc.provide(_Router2.default, _ServerRouter2.default);
  }
  oc.bind('$Router', _Router2.default);
  oc.constant('$RouteNames', _RouteNames2.default);
  oc.constant('$RouterEvents', _Events2.default);

  //Http agent
  oc.bind('$HttpUrlTransformer', _UrlTransformer2.default);
  oc.bind('$HttpAgentProxy', _HttpProxy2.default, ['$HttpUrlTransformer', '$Window']);
  oc.provide(_HttpAgent2.default, _HttpAgentImpl2.default, ['$HttpAgentProxy', '$Cache', _CookieStorage2.default, config.$Http]);
  oc.bind('$Http', _HttpAgent2.default);
  oc.constant('$HttpStatusCode', _StatusCode2.default);

  //Dev tools
  oc.bind('$DevTool', _DevTool2.default);

  //*************END IMA****************
}; //eslint-disable-line no-unused-vars

typeof $IMA !== 'undefined' && $IMA !== null && $IMA.Loader && $IMA.Loader.register('ima/config/bind', [], function (_export, _context) {
 'use strict';
 return {
   setters: [],
   execute: function () {
     _export('default', exports.default);
   }
 };
});
